
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C/C++ 头文件作用 / iVAN</title>

    <meta name="description" content="C/C++ 头文件作用 最近在工作当中遇到了一点小问题,关于C语言头文件的应用问题,主要还是关于全局变量的定义和声明问题.学习C语言已经有好几年了,工作使用也近半年了,但是对于这部分的东西的确还没有深入的思考过.概念上还是比较模糊的,只是之前的使用大多比较简单,并没有牵涉到太复杂的工程,所以定义和声明还是比较简单而明了了的.但是最近的大工程让我在这方面吃到了一点点苦头,虽然看了别人的代码能够很快的改正,但是这些改正背后的原因却不知道.我想大多数喜欢C语言的程序员应该是和我一样的,总喜欢去追究程序问题背后的底层原因,而这">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">C/C++ 头文件作用</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>最近在工作当中遇到了一点小问题,关于C语言头文件的应用问题,主要还是关于全局变量的定义和声明问题.<br />学习C语言已经有好几年了,工作使用也近半年了,但是对于这部分的东西的确还没有深入的思考过.概念上还是比较模糊的,只是之前的使用大多比较简单,并没有牵涉到太复杂的工程,所以定义和声明还是比较简单而明了了的.但是最近的大工程让我在这方面吃到了一点点苦头,虽然看了别人的代码能够很快的改正,但是这些改正背后的原因却不知道.我想大多数喜欢C语言的程序员应该是和我一样的,总喜欢去追究程序问题背后的底层原因,而这也恰恰是我喜欢C语言的最根本的原因.<br />今天看过janders老兄在csdn上的一篇文章后,理解的确加深了很多,而且还学到一些以前不怎么知道的知识.<br />现将文章转载过来,并对文章当中的一些拼写错误做了简单的纠正,同时对文字及布局做了少许修改.</p>
<p>(如果想看原文的,请参考本文底部的链接.)</p>
<p>--------------------------------------------------------------------------------</p>
<p> </p>
<p>C语言中的.h文件和我认识由来已久，其使用方法虽不十分复杂，但我却是经过了几个月的“不懂”时期，几年的“一知半解”时期才逐渐认识清楚他的本来面目。揪其原因，我的驽钝和好学而不求甚解固然是原因之一，但另外还有其他原因。原因一：对于较小的项目，其作用不易被充分开发，换句话说就是即使不知道他的详细使用方法，项目照样进行，程序在计算机上照样跑。原因二：现在的各种C语言书籍都是只对C语言的语法进行详细的不能再详细的说明，但对于整个程序的文件组织构架却只字不提，找了好几本比较著名的C语言著作，却没有一个把.h文件的用法写的比较透彻的。下面我就斗胆提笔，来按照我对.h的认识思路，向大家介绍一下。</p>
<p> </p>
<p>让我们的思绪乘着时间机器回到大学一年级。C原来老师正在讲台上讲着我们的第一个C语言程序: Hello world!</p>
<p> 文件名 First.c</p>
<p>main()</p>
<p>{</p>
<p>     printf(“Hello world!”);</p>
<p>}</p>
<p>     例程-1</p>
<p>看看上面的程序，没有.h文件。是的，就是没有，世界上的万物都是经历从没有到有的过程的，我们对.h的认识，我想也需要从这个步骤开始。这时确实不需要.h文件，因为这个程序太简单了，根本就不需要。那么如何才能需要呢？让我们把这个程序变得稍微复杂些，请看下面这个，</p>
<p>文件名 First.c</p>
<p> </p>
<p> printStr()</p>
<p>{</p>
<p>     printf(“Hello world!”);</p>
<p>}</p>
<p>main()</p>
<p>{</p>
<p>printStr();</p>
<p>}</p>
<p>     例程-2</p>
<p> </p>
<p>还是没有, 那就让我们把这个程序再稍微改动一下.</p>
<p> </p>
<p>文件名 First.c</p>
<p>main()</p>
<p>{</p>
<p>printStr();</p>
<p>}</p>
<p> </p>
<p> </p>
<p> printStr()</p>
<p>{</p>
<p>     printf(“Hello world!”);</p>
<p>}</p>
<p>     例程-3</p>
<p> </p>
<p>等等，不就是改变了个顺序嘛, 但结果确是十分不同的. 让我们编译一下例程-2和例程-3,你会发现例程-3是编译不过的.这时需要我们来认识一下另一个C语言中的概念:作用域.</p>
<p>我们在这里只讲述与.h文件相关的顶层作用域, 顶层作用域就是从声明点延伸到源程序文本结束, 就printStr()这个函数来说，他没有单独的声明,只有定义,那么就从他定义的行开始,到first.c文件结束, 也就是说,在在例程-2的main()函数的引用点上,已经是他的作用域. 例程-3的main()函数的引用点上，还不是他的作用域,所以会编译出错. 这种情况怎么办呢? 有两种方法 ,一个就是让我们回到例程-2,<br />
 顺序对我们来说没什么, 谁先谁后都可以，只要能编译通过,程序能运行, 就让main()文件总是放到最后吧. 那就让我们来看另一个例程,让我们看看这个方法是不是在任何时候都会起作用.</p>
<p>文件名 First.c<br />   play2()<br /> {</p>
<p> ……………….</p>
<p>           play1();</p>
<p> ………………..</p>
<p> <br /> }</p>
<p>   play1()</p>
<p>{<br />    ……………..</p>
<p>           play2();       <br />    ………………<br /> }</p>
<p> </p>
<p> </p>
<p>main()</p>
<p>{</p>
<p>    play1();</p>
<p>}</p>
<p>例程-4</p>
<p> </p>
<p>也许大部分都会看出来了，这就是经常用到的一种算法, 函数嵌套, 那么让我们看看, play1和play2这两个函数哪个放到前面呢?</p>
<p> </p>
<p>这时就需要我们来使用第二种方法,使用声明.</p>
<p>文件名 First.c</p>
<p>play1();</p>
<p>play2();</p>
<p>play2()</p>
<p>{</p>
<p> ……………….</p>
<p> play1();</p>
<p> ………………..<br />}</p>
<p>    play1()<br /> {<br />     …………………….</p>
<p> play2();</p>
<p> ……………………<br /> }</p>
<p> </p>
<p>main()</p>
<p>{</p>
<p>play1();</p>
<p>}</p>
<p>例程-4</p>
<p> </p>
<p>经历了我的半天的唠叨, 加上四个例程的说明,我们终于开始了从量变引起的质变, 这篇文章的主题.h文件快要出现了。</p>
<p>一个大型的软件项目,可能有几千个,上万个play, 而不只是play1,play2这么简单, 这样就可能有N个类似 play1(); play2(); 这样的声明, 这个时候就需要我们想办法把这样的play1(); play2(); 也另行管理, 而不是把他放在.c文件中, 于是.h文件出现了.</p>
<p> </p>
<p>文件名 First.h</p>
<p>play1();</p>
<p>play2();</p>
<p> </p>
<p>文件名 First.C</p>
<p>#include “first.h”</p>
<p>play2()</p>
<p>{</p>
<p> ……………….</p>
<p> play1();</p>
<p> ………………..</p>
<p>}</p>
<p>    play1();</p>
<p>{</p>
<p>……………………..</p>
<p>     play2();</p>
<p>  ……………………</p>
<p>}</p>
<p> </p>
<p> </p>
<p>main()</p>
<p>{</p>
<p>play1();</p>
<p>}</p>
<p>例程-4</p>
<p> </p>
<p>各位有可能会说,这位janders大虾也太罗嗦了，上面这些我也知道, 你还讲了这么半天, 请原谅, 如果说上面的内容80%的人都知道的话,那么我保证,下面的内容,80%的人都不完全知道. 而且这也是我讲述一件事的一贯作风,我总是想把一个东西说明白,让那些刚刚接触C的人也一样明白.</p>
<p>上面是.h文件的最基本的功能, 那么.h文件还有什么别的功能呢? 让我来描述一下我手头的一个项目吧.</p>
<p> </p>
<p>这个项目已经做了有10年以上了，具体多少年我们部门的人谁都说不太准确,况且时间并不是最主要的，不再详查了。是一个通讯设备的前台软件, 源文件大小共 51.6M, 大大小小共1601个文件, 编译后大约10M, 其庞大可想而知, 在这里充斥着错综复杂的调用关系,如在second.c中还有一个函数需要调用first.c文件中的play1函数, 如何实现呢?</p>
<p> </p>
<p>Second.h 文件</p>
<p> </p>
<p>play1();</p>
<p> </p>
<p> </p>
<p>second.c文件</p>
<p> </p>
<p>***()</p>
<p>{</p>
<p>…………….</p>
<p>Play();</p>
<p>……………….</p>
<p>}</p>
<p>例程-5</p>
<p> </p>
<p>在second.h文件内声明play1函数，怎么能调用到first.c文件中的哪个play1函数中呢? 是不是搞错了，没有搞错, 这里涉及到c语言的另一个特性:存储类说明符.</p>
<p>C语言的存储类说明符有以下几个, 我来列表说明一下</p>
<p>  </p>
<p> 说明符<br />  用    法<br /> <br /> Auto<br />  只在块内变量声明中被允许, 表示变量具有本地生存期.<br /> <br /> Extern<br />  出现在顶层或块的外部变量函数与变量声明中，表示声明的对象具有静态生存期, 连接程序知道其名字.<br /> <br /> Static<br />  可以放在函数与变量声明中,在函数定义时,只用于指定函数名,而不将函数导出到链接程序,在函数声明中,表示其后边会有定义声明的函数,存储类型static.在数据声明中,总是表示定义的声明不导出到连接程序.<br /> </p>
<p> </p>
<p> </p>
<p>无疑, 在例程-5中的second.h和first.h中,需要我们用extern标志符来修饰play1函数的声明,这样,play1()函数就可以被导出到连接程序, 也就是实现了无论在first.c文件中调用,还是在second.c文件中调用,连接程序都会很聪明的按照我们的意愿,把他连接到first.c文件中的play1函数的定义上去, 而不必我们在second.c文件中也要再写一个一样的play1函数.</p>
<p>但随之有一个小问题, 在例程-5中,我们并没有用extern标志符来修饰play1啊, 这里涉及到另一个问题, C语言中有默认的存储类标志符. C99中规定, 所有顶层的默认存储类标志符都是extern . 原来如此啊, 哈哈. 回想一下例程-4, 也是好险, 我们在无知的情况下, 竟然也误打误撞,用到了extern修饰符, 否则在first.h中声明的play1函数如果不被连接程序导出,那么我们在在play2()中调用他时,<br />
 是找不到其实际定义位置的 .</p>
<p> </p>
<p>那么我们如何来区分哪个头文件中的声明在其对应的.c文件中有定义,而哪个又没有呢?这也许不是必须的，因为无论在哪个文件中定义，聪明的连接程序都会义无返顾的帮我们找到，并导出到连接程序, 但我觉得他确实必要的. 因为我们需要知道这个函数的具体内容是什么,有什么功能, 有了新需求后我也许要修改他，我需要在短时间内能找到这个函数的定义, 那么我来介绍一下在C语言中一个人为的规范:</p>
<p> </p>
<p>在.h文件中声明的函数,如果在其对应的.c文件中有定义,那么我们在声明这个函数时,不使用extern修饰符, 如果反之,则必须显示使用extern修饰符.</p>
<p> </p>
<p>这样,在C语言的.h文件中,我们会看到两种类型的函数声明. 带extern的,还不带extern的, 简单明了,一个是引用外部函数，一个是自己生命并定义的函数.</p>
<p>最终如下:</p>
<p>Second.h 文件</p>
<p> </p>
<p>Extern play1();</p>
<p> </p>
<p> </p>
<p>上面洋洋洒洒写了那么多都是针对函数的，而实际上.h文件却不是为函数所御用的. 打开我们项目的一个.h文件我们发现除了函数外,还有其他的东西, 那就是全局变量.</p>
<p> </p>
<p>在大型项目中，对全局变量的使用不可避免, 比如,在first.c中需要使用一个全局变量G_test, 那么我们可以在first.h中,定义 TPYE G_test. 与对函数的使用类似, 在second.c中我们的开发人员发现他也需要使用这个全局变量, 而且要与first.c中一样的那个, 如何处理? 对,我们可以仿照函数中的处理方法, 在second.h中再次声明TPYE G_test, 根据extern的用法,以及c语言中默认的存储类型,<br />
 在两个头文件中声明的TPYE G_test,其实其存储类型都是extern, 也就是说不必我们操心, 连接程序会帮助我们处理一切. 但我们又如何区分全局变量哪个是定义声明,哪个是引用声明呢?这个比函数要复杂一些, 一般在C语言中有如下几种模型来区分:</p>
<p> </p>
<p>1、初始化语句模型</p>
<p>顶层声明中，存在初始化语句是，表示这个声明是定义声明，其他声明是引用声明。C语言的所有文件之中，只能有一个定义声明。</p>
<p>按照这个模型，我们可以在first.h中定义如下TPYE G_test=1；那么就确定在first中的是定义声明，在其他的所有声明都是引用声明。</p>
<p>2、省略存储类型说明</p>
<p>在这个模型中，所有引用声明要显示的包括存储类extern，而每个外部变量的唯一定义声明中省略存储类说明符。</p>
<p>这个与我们对函数的处理方法类似，不再举例说明。</p>
<p> </p>
<p>    这里还有一个需要说明，本来与本文并不十分相关，但前一段有个朋友遇到此问题，相信很多人都会遇到，那就是数组全局变量。</p>
<p> </p>
<p>他遇到的问题如下：</p>
<p>在声明定义时，定义数组如下：</p>
<p>int G_glob[100];</p>
<p> </p>
<p>在另一个文件中引用声明如下：</p>
<p>int * G_glob;</p>
<p> </p>
<p>在vc中，是可以编译通过的，这种情况大家都比较模糊并且需要注意，数组与指针类似，但并不等于说对数组的声明起变量就是指针。上面所说的的程序在运行时发现了问题，在引用声明的那个文件中，使用这个指针时总是提示内存访问错误，原来我们的连接程序并不把指针与数组等同，连接时，也不把他们当做同一个定义，而是认为是不相关的两个定义，当然会出现错误。正确的使用方法是在引用声明中声明如下：</p>
<p> </p>
<p>int G_glob[100];</p>
<p> </p>
<p>并且最好再加上一个extern，更加明了。</p>
<p> </p>
<p>extern int G_glob[100];</p>
<p> </p>
<p>    另外需要说明的是，在引用声明中由于不需要涉及到内存分配，可以简化如下，这样在需要对全局变量的长度进行修改时，不用把所有的引用声明也全部修改了。</p>
<p> </p>
<p>extern int G_glob[];</p>
<p> </p>
<p>    C语言是现今为止在底层核心编程中，使用最广泛的语言，以前是，以后也不会有太大改变，虽然现在java,.net等语言和工具对c有了一定冲击，但我们看到在计算机最为核心的地方，其他语言是无论如何也代替不了的，而这个领域也正是我们对计算机痴迷的程序员所向往的。</p>
<p> </p>
<p>--------------------------------------------------------------------------------</p>
<p>好了,看完文章,对与C语言头文件的作用应该有了跟多的理解吧,如果这些你原本都知道了,那么仅当是温习一下而已,如果原本不知道,那么恭喜你,现在又学到一些技巧和知识.</p>
<p>对于全局变量的定义和声明,其实还有另外一个解决的方法,聪明的你可能早已经猜到了:),没错,就是用宏定义的技巧实现.比如a.h文件当中有: <br />#ifdef AAA<br /> int i=0;<br />#else<br /> int i;<br />#endif<br />那么,在a.c文件当中,有如下语句:<br />......<br />#define AAA<br />#include "a.h"<br />......<br />而对于其他的任何包含a.h文件的头文件或者.c源文件,只需要直接包含a.h就行了<br />......<br />#include "a.h"<br />......<br />这样就可以达到在a.c文件当中定义变量一次,而在其他的文件当中声明该变量的目的.<br />当然了,你完全可以根据自己的需要来决定在哪个需要包含a.h的文件当中定义宏AAA,但是我要说的是<br />在同一个工程的不同的需要包含a.h的文件当中,你只能定义AAA一次,否则在连接这些目标文件时会出现<br />重复定义的错误,即使你的单独目标文件编译没有任何的问题.</p>
<p>当然,这里说的仅仅是对全局变量的声明技巧,强烈的推介大家在头文件中使用宏定义实现对整个头文件的防止重复包含,当然了,这个技巧大多数的c语言程序员都懂.<br />#ifndef XXX<br />#define XXX</p>
<p>#endif<br />这样做会让你的程序更加稳健,很大程度上减少了不必要的麻烦...</p>
<p>最后给出一点点全局变量使用需要注意的问题,这也仅仅是个建议,或者说一种编程习惯 ;)<br />1) 所有全局变量全部以g_开头,并且尽可能声明成static类型. <br />2) 尽量杜绝跨文件访问全局变量.如果的确需要在多个文件内访问同一变量,应该由该变量定义所在文件内提供GET/PUT函数实现. <br />3) 全局变量必须要有一个初始值,全局变量尽量放在一个专门的函数内初始化. <br />4) 如调用的函数少于三个,请考虑改为局部变量实现. <br /> </p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p>简单办法，先写完整程序，再把一部分抽出去，抽出去的存到 自己的头文件里，在抽出的地方写 #include ...</p>
<p> </p>
<p>例如，完整程序（计算平均值）：</p>
<p>#include&lt;stdio.h&gt;</p>
<p> </p>
<p>double mean(double *y, int N){</p>
<p>int i;</p>
<p>double s=0.0;</p>
<p>for (i=0;i&lt;N;i++) s=s+y[i];</p>
<p>s = s / (double) N;</p>
<p>return s;</p>
<p>}</p>
<p>void main()</p>
<p>{</p>
<p>double x[10]={1,2,3,4,5,6,7,8,9,10};</p>
<p>printf("mean = %lf\n", mean(x,10));</p>
<p>}</p>
<p>----------------------------------------------</p>
<p>抽出部分 存入 a_x.h ：</p>
<p>double mean(double *y, int N){</p>
<p>int i;</p>
<p>double s=0.0;</p>
<p>for (i=0;i&lt;N;i++) s=s+y[i];</p>
<p>s = s / (double) N;</p>
<p>return s;</p>
<p>}</p>
<p>--------------------------------</p>
<p> </p>
<p> 在c/c++语言中的头文件其实是为了搜寻对应的类型和函数信息的</p>
<p>比如在头文件中可以声明一个函数，但这个函数可能定义在任何地方</p>
<p>比如一个静态库或者动态导入库lib中，或者可以直接以原代码的方式写在cpp/c文件中头文件提供的服务叫做类型映射（phototype）</p>
<p> </p>
<p>函数在c/c++语言中也是一种类型函数在声明的时候其实仅仅是说明了对应的函数调用协议，函数名称和参数类型这样就可以明确的指导编译器如何创建这个函数对应的调用代码而寻找这个函数的工作交给了链接器注意 编译器在vc里边叫做cl，链接器在vc里边叫做link。</p>
<p> </p>
<p>cl负责生成obj，每一个cpp/c文件会生成一个obj文件</p>
<p>这个obj里边包含了直接由c/cpp源程序所生成的汇编代码，这个c/cpp文件需要查找的符号（这个后面再说）</p>
<p> </p>
<p>link其实和咱们上微机原理汇编课的时候用的Link很像</p>
<p>他负责将每一个obj中的符号查找表中的东西转换为一个地址</p>
<p>这个地址就是最后编译完成后的exe文件的函数对应这个函数的入口地址。</p>
<p> </p>
<p>符号，就是这个函数或者对象通过编译器后所产生的名称</p>
<p>在c语言中一个符号由这个函数或者这个对象的名称和这个函数的调用协议组成</p>
<p>这也是为什么c语言不支持重载的原因</p>
<p>（还记得重载吧？重载就是参数类型或个数不同，</p>
<p>参数和个数都相同的叫做重写，重写只能用在类的函数的继承中）</p>
<p>而c++会在每一个函数的前后添加一堆用于表示这个函数的调用方法所属类型，名字空间和调用参数类型等的大量字符</p>
<p>用来区分每一个函数</p>
<p>比如一个函数</p>
<p>int Test(); 根据不同的命名方法可能被不同的命名</p>
<p>如果到定义了extern "C" 如下：</p>
<p>extern "C" int Test();</p>
<p>这个函数就被vc编译器按c语言的方式命名为 _Test</p>
<p> 其中的前划线 _表示这个函数的调用协议为__cdecl</p>
<p> Test就是这个函数的名称</p>
<p>如果使用vc编译器直接编译这个函数int Test();</p>
<p>他就被当作int __cdecl Test(void); 编译成 ?Test@@YAHXZ</p>
<p> 其中的? 和 @@YAHXZ都是编译器加上去的</p>
<p> ? 和 @@YAH 是用来表示调用协议的</p>
<p> 其中的H为返回值是int</p>
<p> X表示没有参数。</p>
<p> Z是函数名称结束修饰</p>
<p> </p>
<p>调用协议</p>
<p>指函数的参数传递使用的方式</p>
<p>有__cdecl __fastcall __stdcall __thiscall 等</p>
<p>__cdecl 是c语言的调用方式</p>
<p>__fastcall 使用寄存器传递参数</p>
<p>__stdcall 使用栈传递参数，并且其压栈顺序为从右到左，由被调用函数来清除栈</p>
<p>__thiscall 是类对象的方法调用方式，这种调用方式不能直接由程序指定</p>
<p> </p>
<p>如果一个函数的是被实现在cpp或者c文件中的时候，就必须保证这个cpp或者c文件所产生的符号与这个函数的声明所产生的</p>
<p>符号相同，否则链接器在链接的时候就会发生无法找到符号的错误</p>
<p> </p>
<p>如何保证这个符号是相同的呢？</p>
<p>只要在cpp或者c文件中包含这个头文件</p>
<p>或者如果能保证所生成的符号相同则根本就不用h文件也能工作</p>
<p>比如如下程序</p>
<p> </p>
<p>// 这是main.cpp文件的东西</p>
<p>int Test();</p>
<p> </p>
<p>int main()</p>
<p>{</p>
<p> Test();</p>
<p>}</p>
<p> </p>
<p>// 这是test.cpp文件的东西</p>
<p>int Test()</p>
<p>{</p>
<p> return 1;</p>
<p>}</p>
<p>这里就完全没有用头文件</p>
<p> </p>
<p>注意事项：</p>
<p>1。如果是使用了c文件作为函数的载体而编译器为微软的vc，</p>
<p>需要在h文件中添加extern "C"通知编译器使用c的命名规则</p>
<p>最好使用判断</p>
<p>#ifdef __cplusplus</p>
<p>extern "C" {</p>
<p>#endif</p>
<p> </p>
<p>...</p>
<p>函数声明</p>
<p>...</p>
<p> </p>
<p>#ifdef __cplusplus</p>
<p>}</p>
<p>#endif</p>
<p>这样在c编译器上也能使用这个头文件了</p>
<p>2。c/cpp文件与头文件名称无关</p>
<p>3。如果一个头文件中定义了一个结构或者类，那么在h文件中最好使用防止多次包含的</p>
<p>#ifndef __XXX__H__</p>
<p>#define __XXX__H__</p>
<p> </p>
<p>...</p>
<p>//类或结构定义</p>
<p>class a</p>
<p>{</p>
<p> ...</p>
<p>};</p>
<p>...</p>
<p> </p>
<p>#endif</p>
<p>这里的XXX就是这个头文件的名称，这个名称是可以随便起的，只要不起重。</p>
<p>但c/cpp文件中不需要添加这些东西</p>
<p> </p>
<p>或者如果使用了vc6作为编译器它支持</p>
<p>#pragma once</p>
<p>在h文件的最前面写上这句话就可以保证这个头文件只会被处理一遍</p>
<p> </p>
<p> </p>
<p>程序变:</p>
<p>#include&lt;stdio.h&gt;</p>
<p>#include "a_x.h"</p>
<p>void main()</p>
<p>{</p>
<p>double x[10]={1,2,3,4,5,6,7,8,9,10};</p>
<p>printf("mean = %lf\n", mean(x,10));</p>
<p>}</p>
<p>=============================================</p>
<p>你要是愿意随便抽一块也可以，例如抽出（也叫 a_x.h）：</p>
<p>double mean(double *y, int N){</p>
<p>int i;</p>
<p>double s=0.0;</p>
<p>for (i=0;i&lt;N;i++) s=s+y[i];</p>
<p>s = s / (double) N;</p>
<p>return s;</p>
<p>}</p>
<p>void main()</p>
<p>{</p>
<p>------------------------</p>
<p>程序变:</p>
<p>#include&lt;stdio.h&gt;</p>
<p>#include "a_x.h"</p>
<p>double x[10]={1,2,3,4,5,6,7,8,9,10};</p>
<p>printf("mean = %lf\n", mean(x,10));</p>
<p>}</p>
<p>==============================</p>
<p>语法上，功能上，两种抽法都可以。但第一种方法较好--程序可读性好，不易出错。</p>
<p> </p>
<p>一般情况下，头文件里放 函数原型，全局量声明 和 函数定义。</p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p>C语言中的头文件可以自己写吗？</p>
<p>电脑圈圈 发表于 2006-3-17 22:57:00</p>
<p> </p>
<p>2</p>
<p>推荐</p>
<p>一些初学C语言的人，不知道头文件（*.h文件）原来还可以自己写的。只知道调用系统库函数时，要使用＃i nclude语句将某些头文件包含进去。其实，头文件跟.C文件一样，是可以自己写的。头文件是一种文本文件，使用文本编辑器将代码编写好之后，以扩展名.h保存就行了。头文件中一般放一些重复使用的代码，例如函数声明，变量声明，常数定义，宏的定义等等。当使用＃i nclude语句将头文件引用时，相当于将头文件中所有内容，复制到＃i<br />
 nclude处。为了避免因为重复引用而导致的编译错误，头文件常具有</p>
<p>#ifndef   LABEL</p>
<p>#define   LABEL</p>
<p>   //代码部分</p>
<p>#endif</p>
<p>的格式。其中，LABEL为一个唯一的标号，命名规则跟变量的命名规则一样。常根据它所在的头文件名来命名，例如，如果头文件的文件名叫做hardware.h，</p>
<p>那么可以这样使用：</p>
<p>#ifndef   __HARDWARE_H__</p>
<p>#define   __HARDWARE_H__</p>
<p> //代码部分</p>
<p>#endif</p>
<p>这样写的意思就是，如果没有定义__HARDWARE_H__，则定义__HARDWARE_H__，并编译下面的代码部分，直到遇到#endif。这样，当重复引用时，由于__HARDWARE_H__已经被定义，则下面的代码部分就不会被编译了，这样就避免了重复定义。</p>
<p>另外一个地方就是使用include时，使用引号与尖括号的意思是不一样的。使用引号(“”)时，首先搜索工程文件所在目录，然后再搜索编译器头文件所在目录。而使用尖括号(&lt;&gt;)时，刚好是相反的搜索顺序。假设我们有两个文件名一样的头文件hardware.h，但内容却是不一样的。一个保存在编译器指定的头文件目录下，我们把它叫做文件I；另一个则保存在当前工程的目录下，我们把它叫做文件II。如果我们使用的是＃i<br />
 nclude &lt;hardware.h&gt;，则我们引用到的是文件I。如果我们使用的是＃i nclude “hardware.h”，则我们引用的将是文件II。笔者以前就遇到过一个同事问，为什么他修改了那个头文件里面的内容，好象跟没有修改一样？就是因为他有两个一样的头文件（就像我们刚描述的那样），他是使用＃i nclude&lt;hardware.h&gt;引用的，而他修改时，却是当前工程所在的目录下的那个文件。</p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p>#include 的本质就是把对应的文件直接拷贝到这一行里面</p>
<p>要理解头文件，主要是要理解“声明”</p>
<p>C/C++中，所有使用到得变量、函数、类都要是声明过得，就是说，要有一行语句来告诉编译器，我有一个名字叫XXX的???类型的变量（函数、类）。</p>
<p>然后还有一个因素就是，在编译的时候，程序是按照每个.C或.CPP文件单独编译的。</p>
<p>也就是说，对于每个C文件中，如果都用到了同一个函数（比如printf），那么，我在每个对应文件中写一遍printf的声明明显是很麻烦的。所以我把这个声明单独写了一个文件，为了区别，我把扩展名记做.h，在需要使用对应的函数（类）的时候，我就不需要去拷贝函数的声明，而只需要#include对应头文件就可以了，系统自动帮你拷贝进来——C语言提供的头文件，按照函数功能分类好了，比如数学函数就都写在了math.h里面，一包含就全包含，不管你用没用到cos()这个函数或者其他什么。</p>
<p> </p>
<p>当然，由于.h文件中也可以包含其他.h文件，所以为了不重复声明或定义，需要用宏做相应的处理，这个不是要理解的东西，而是照着写。</p>
<p> </p>
<p>看到你的补充，在这里我也补充下答案</p>
<p>对于自己定义的函数，首先，肯定的是，你至少需要在一个C文件中定义它，否则链接会出错。当你想在任何一个文件中使用的时候，你只需要让这个文件包函数声明所在的头文件即可。</p>
<p>具体来说：</p>
<p>a.h中声明了了</p>
<p>int a( int x);</p>
<p>a.c中实现这个函数，需要有类似代码</p>
<p>#include "a.h"</p>
<p>//.....其他代码</p>
<p>int a(int x)</p>
<p>{</p>
<p>return x*x;</p>
<p>}</p>
<p>如果在b.c中想使用这个，则只要在b.c中这样就可以：</p>
<p>#include "a.h"</p>
<p>//....其他代码</p>
<p>x = a(x);</p>
<p>//...其他代码</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:32:25</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8/" title="存储">存储</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>C/C++ 头文件作用的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZEa0Bp.html" rel="bookmark">linux编程-怎么让自己写的头文件在一个&period;c文件中其作用？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 怎么让自己写的头文件在一个.c文件中其作用? count.h 1 #ifndef COUNT_H 2 #define COUNT_H 3 int count(int x); 4 #endifcount.c 1 #include 2 int count(int x) 3 {return 2*x; } num.c 1 #include&quot;&quot;stdio.h&quot;&quot; 2 #include&quot;&quot;count.h&quot;&quot; 3 int main			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqAZnKM.html" rel="bookmark">语言-static 函数定义在头文件中有什么作用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 static 函数定义在头文件中有什么作用 static 函数定义在头文件中有什么作用?学渣求教,static 不就是要限制作用域吗? 解决方案 是限定范围的,你的理解没有错.所以在 .h 中定义的 static 函数只能供本头文件中定义的函数使用 解决方案二: static表示静态类型.同时限定在模块内可见. 解决方案三: static用于声明静态变量,添加了该标识意味着这个变量的值在整个程序运行期间都存在的 解决方案四: static是静态变量.局部变量.其作用域是从定义点到ret			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN1XVyb.html" rel="bookmark">方法-C语言头文件里放声明，其实现放哪？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 C语言头文件里放声明,其实现放哪? 我写了一个头文件a.h,实现在a.c中,主文件中#include &quot;a.h&quot;,报错...我想知道头文件的声明和定义的规范使用方法..谢谢.. 解决方案 首先搞清楚,include和头文件的关系. include的作用是将这个文件的内容插入到include所在的位置,从而构成一个完整的源代码文件被编译. 那么头文件是什么,实际上头文件里可以放任何东西,源代码文件也可以放任何东西,include也可以随意包含. 只是看这三者放在一起,经过替换,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8ZrQPb.html" rel="bookmark">C&plus;&plus;中头文件和源文件详细介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C++中的头文件和源文件详解 一.C++编译模式 通常,在一个C++程序中,只包含两类文件--.cpp文件和.h文件.其中,.cpp文件被称作C++源文件,里面放的都是C++的源代码:而.h文件则被称作C++头文件,里面放的也是C++的源代码. C+ +语言支持&quot;分别编译&quot;(separate compilation).也就是说,一个程序所有的内容,可以分成不同的部分分别放在不同的.cpp文件里..cpp文件里的东西都是相对独立的,在编 译(compile)时不需要与其他文件互通,只需要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDWEelp.html" rel="bookmark">头文件编写-头文件自包含是什么意思？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 头文件自包含是什么意思? 头文件自包含是什么意思?能给个例子吗?作用是什么呢?谢谢!............. 解决方案 说明:简单的说,自包含就是任意一个头文件均可独立编译.如果一个文件包含某个头文件,还要包含另外一个头文件才能工作的话,就会增加交流障碍,给这个头文件的用户增添不必要的负担. 示例: 如果a.h不是自包含的,需要包含b.h才能编译,会带来的危害: 每个使用a.h头文件的.c文件,为了让引入的a.h的内容编译通过,都要包含额外的头文件b.h. 额外的头文件b.h必须在a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2Pm1Vp.html" rel="bookmark">关于头文件是否参与编译的讨论</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.文章来由 写项目的时候发现了这个问题,又是一个比较底层的问题,首先说明,这篇文章只是我根据查阅的资料和做的实验提出的一个讨论,并不一定就是正确答案.因为这个问题网上众说纷纭,我很欢迎大家参与这个讨论,一起搞懂这个问题~~~ 二.问题的提出 问题就是... 2.1 问题1(主问题): 头文件是否真正参与编译? 先上一个网上的标准答案: .h的内容被插入到.c中,作为.c的内容被编译..h文件本身不直接参加编译. 据我理解,这句话就是说明了头文件不直接参与编译,是作为一个插入来理解. 也就是说:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwlXEp.html" rel="bookmark">程序设计方式 之 嵌套头文件包含方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				       一直以来写程序有个习惯,喜欢把常用的STL类,或者其他常用的类,变量,宏等定义到一个文件内,然后在使用其中一个类的地方包含这个文件.一直再使用,也一直存在困惑,这种设计方式的能否放心大胆的使用,对它始终心存畏惧,所有这些促使我完成这篇文章,并且经过种种测试,有足够的信心继续使用这种设计方式.        操作如下 定义base.h文件,包含基本的STL类,并且通过typedef建立不同的映射关系,以便减少不同的文件出现过多vector&lt;string&gt;之类的声明方式.当需要使用v			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZqjdb.html" rel="bookmark">getegid函数-请问getegid这个函数在vc中的哪个头文件中</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 请问getegid这个函数在vc中的哪个头文件中 请问vc中有这个函数吗,有的话是在哪个头文件中呢,没有的话是用什么代替呢?我在msdn上搜过,那上面显示头文件是,但是我试了一下显示没有这个头文件的错误信息. 解决方案 参考C语言getegid()函数:获得组识别码 是C语言,没有说是VC. 头文件: #include &lt;unistd.h&gt; #include &lt;sys/types.h&gt; 定义函数:gid_t getegid(void); 函数说明:getegid()用来取			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rWRNz.html" rel="bookmark">indows编程 句柄-关于winnt&period;h头文件中有关句柄（HANDLE）的一段源代码的两个疑问，求大神解答。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 关于winnt.h头文件中有关句柄(HANDLE)的一段源代码的两个疑问,求大神解答. 大家好!我对winnt.h中的这段代码有疑问: #ifdef STRICT typedef void *HANDLE; #if 0 &amp;&amp; (_MSC_VER &gt; 1000) #define DECLARE_HANDLE(name) struct name##__; typedef struct name##__ *name #else #define DECLARE_HANDLE(nam			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOlx3b.html" rel="bookmark" class="title">web设计-web页面展示-层级关系</a>
					<div>
						问题描述 web页面展示-层级关系 在web页面除了树形结构.还有什么结构可以展现层级关系,现在主流是什么? 解决方案 其实比起树结构,我觉得用图结构来描述web页面更为合适~只要都是对链表数据结构的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQBkKM.html" rel="bookmark" class="title">ubuntu 10&period;04加windows双系统中如何把Windows设为默认启动项</a>
					<div>
						安装了WindowsXP和Ubuntu10.04双系统后(后装的Ubuntu),系统默认启动的操作系统是Ununtu 10.04,想更改为默认启动WindowsXP,参照以前版本的Ubuntu,只需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQVGQM.html" rel="bookmark" class="title">通过SEO，2个月给我带来了5万元的收入</a>
					<div>
						seo 大家打开百度:搜索传奇私服 排名前三的站就有偶的站了. www.sf172.com  今天我就根据这个站和大家一起分析一下网站的优化. 请大家打开:源文件.我们一点点分析  这是前面的标签.我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP4j8p.html" rel="bookmark" class="title">Photoshop调色风景图片&colon;艳丽的秋季色调</a>
					<div>
						秋季色调色方法有很多.本文介绍一种较为快捷的方式.处理之前现在Lab模式进行简单的图片叠加,适当增加图片的暖色,然后再回到RGB模式,用通道混合器快速转为暖色,最后调整好局部颜色即可.原图 最终效果  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnQXZM.html" rel="bookmark" class="title">如何配置Java Server Page运行环境</a>
					<div>
						server NT下安装JSP Windows NT 4.0,Windows 2000 professional,windows 2000 server jdk1_2_2-001-win.exe to ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx4njb.html" rel="bookmark" class="title">在word中插入并自动更新excel表格</a>
					<div>
						如何在word中插入excel表格,并且表格要随着excel文件内容的跟新而更新,我今天简单测试了一下,很容易完成.现在说一下步骤: 在首先之前,插入一句看似没用,实际上又很重要的话:我的office ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE6Nob.html" rel="bookmark" class="title">用CSS3写的模仿iPhone中的返回按钮</a>
					<div>
						好像写这个有点晚了,iOS已经从拟物化的年代进化到了扁平化的年代,那些圆角+渐变+阴影的年代已经过去,不过在此仍然要去说下古老的iOS返回按钮. 在过去的年代,大家都以iOS的设计元素为自己移动版页面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eANob.html" rel="bookmark" class="title">迅雷网游加速器评测</a>
					<div>
						  大家知道,在玩PC游戏的时候,通常计算机平台的硬件配置起到了决定性的作用.然而除此之外,还有另外一个方面也是非常重要的,那就是游戏所处的当前网络环境状态,特别是对于网络游戏来说,网络速度的快慢直接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z721G5p.html" rel="bookmark" class="title">移动硬盘该如何分区</a>
					<div>
						  许多用户喜欢采用外部存储介质存储数据,例如,外部移动硬盘.我们如何运用移动硬盘分区工具对外部硬盘进行分区呢?这里有一个免费的第三方分区工具,可以以帮助外部移动硬盘分区.确定地说,免费的分区助手能实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6VPlz.html" rel="bookmark" class="title">怎么样在进度条中显示processbar的value值</a>
					<div>
						问题描述 怎么样在进度条中显示processbar的value值 怎么样在进度条中显示processbar的value值?怎么制作中间带有数字百分比的进度条控件? 解决方案 这里有个现成的参考下:ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA0aZM.html" rel="bookmark" class="title">opencv-用c来实现bmp图片的双线性插值和旋转</a>
					<div>
						问题描述 用c来实现bmp图片的双线性插值和旋转 用c来实现bmp图片的双线性插值和旋转,求大神解答啊,现在实在弄不出来,opencv也可以的 解决方案 双线性插值是最好实现的算法了至于旋转,需要先  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3EjJz.html" rel="bookmark" class="title">benchmark-redis3&period;0集群性能问题</a>
					<div>
						问题描述 redis3.0集群性能问题 redis3.0集群为何在3主3从,6主6从,12主12从的集群环境下使用benchmark测试的性能几乎相同? 解决方案 不明白你想问什么,能把问题说明的再清 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6Dywb.html" rel="bookmark" class="title">【JAVA秒会技术之ActiveMQ】ActiveMQ的快速入门</a>
					<div>
						ActiveMQ的快速入门 一.ActiveMQ介绍 1.ActiveMQ简介         MQ,即Message Queue,消息队列.         ActiveMQ,是Apache出品,最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Qo4Jp.html" rel="bookmark" class="title">全球数据中心市场现状及趋势</a>
					<div>
						一.亚太地区带动全球IDC市场规模持续增长   据中国IDC圈最新发布的&lt;2012-2013年度中国IDC产业发展研究报告&gt;数据显示,2012年,全球IDC市场整体规模达到255.2亿美元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RdBjz.html" rel="bookmark" class="title">C&num; DataGridView添加新行的2个方法&lowbar;C&num;教程</a>
					<div>
						可以静态绑定数据源,这样就自动为DataGridView控件添加 相应的行.假如需要动态为DataGridView控件添加新行,方法有很多种,下面简单介绍如何为DataGridView控件动态添加新行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRl66b.html" rel="bookmark" class="title">《HTML5&plus;CSS3网页设计入门必读》&mdash;&mdash;第1章　标记简史1&period;1　从IETF到W3C：HTML 4的诞生过程</a>
					<div>
						第1章 标记简史 HTML是万维网(World Wide Web)的统一语言.通过它所提供的标签,人类已经创建了各种各样令人惊奇的超链接文档网络.从Amazon.eBay和Wikipedia,到个人博 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjN3OM.html" rel="bookmark" class="title">《社会智能与综合集成系统》&mdash;第1章1&period;5节集体智慧和社会智能</a>
					<div>
						1.5 集体智慧和社会智能 社会智能与综合集成系统 从思维系统性.人们的社会性研究出发,促进创造思维,以期达到发展社会智能的目的. 1.5.1 思维系统观 1．思维系统性 一般逻辑研究认为,抽象思维的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjxO8M.html" rel="bookmark" class="title">基金公司对决互联网金融</a>
					<div>
						投资者通过腾讯微信理财通提交华夏财富宝基金的赎回业务,到账时间调整为赎回的第二个工作日. 与此形成鲜明对比的是,投资者在华夏直销的电商平台购买活期通,赎回实现T+0到账,申购端亦能做到&quot;即存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJBPqp.html" rel="bookmark" class="title">svn权限配置的一点问题</a>
					<div>
						保存为:utf-8格式,       不然的话老报&quot;权限配置不正确&quot;的错误         commit强制写日志: 版本库中hooks目录下,新建文本文件,改名为 pre-com ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8orZp.html" rel="bookmark" class="title">C&num;&lpar;asp&period;net&rpar;多线程用法示例&lpar;可用于同时处理多个任务&rpar;&lowbar;C&num;教程</a>
					<div>
						本文实例讲述了C#(asp.net)多线程用法.分享给大家供大家参考,具体如下: using System; using System.Collections.Generic; using Syste ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1N91jp.html" rel="bookmark" class="title">SQL server高级应用 收藏版&lowbar;MsSql</a>
					<div>
						一. 建库,建表,加约束. 1.1建库 复制代码 代码如下: use master go if exists (select * from sysdatabases where name='MyDat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJO26Db.html" rel="bookmark" class="title">MySQL日期数据类型、时间类型使用总结&lowbar;Mysql</a>
					<div>
						MySQL 日期类型:日期格式.所占存储空间.日期范围 比较. 日期类型        存储空间       日期格式                 日期范围 ------------ ------ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmZ48p.html" rel="bookmark" class="title">用显卡加速，轻松把笔记本打造成取暖器的办法！&lowbar;javascript技巧</a>
					<div>
						最近破事比较多,好久没来这里写异想天开的玩意了.不过今天早上倒是想到个很有趣的东东,所以花了半小时简单的琢磨了会,顺便写点分享下. 天气凉的时候,或者冻手冻脚的时候~ 于是这热乎乎的笔记本正好成了烘手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0Yw5z.html" rel="bookmark" class="title">VC2010 如何在CTabView 某一视图中，建立分割视图</a>
					<div>
						问题描述 VC2010如何在CTabView某一视图中,建立分割视图AddView(RUNTIME_CLASS(View1),_T(&quot;View1&quot;),100);AddView(RU ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8N0Kb.html" rel="bookmark" class="title">做SEO千万别犯的7个要点</a>
					<div>
						1.经常换网站程序.有很多新手在接触网站的时候,因为对SEO没有太深的了解,往往凭借个人喜好,经常变更网站程序.殊不知网站建成之初,蜘蛛就形成了对该站的爬行规律,突然变换网站程序,会使蜘蛛辨别不明,最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Dk3ab.html" rel="bookmark" class="title">微软发出邀请函 9月30日有望推Windows 9预览版</a>
					<div>
						微软宣布9月30日召开发布会 有望推Windows 9预览版新浪科技讯 北京时间9月16日凌晨消息,微软周一宣布,该公司将于9月30日在旧金山召开一次&quot;Windows发布会&quot;,并已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8GPYPM.html" rel="bookmark" class="title">理解AngularJs指令&lowbar;AngularJS</a>
					<div>
						对于指令,可以把它简单的理解成在特定DOM元素上运行的函数,指令可以扩展这个元素的功能. 首先来看个完整的参数示例再来详细的介绍各个参数的作用及用法: angular.module('myApp',  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXZGvz.html" rel="bookmark" class="title">c&sol;s端，双击打开一个文档，ctrl&plus;e还可以打开同一文档，如何屏蔽ctrl&plus;e的打开功能</a>
					<div>
						问题描述 c/s端,双击打开一个文档,ctrl+e还可以打开同一文档,如何屏蔽ctrl+e的打开功能当然了,ctrl+e可以重复N次打开同一文档,有什么办法可以屏蔽ctrl+e的打开功能比如是否可以获 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEJk0JM.html" rel="bookmark" class="title">IMAX影院将采用DLP影院投影解决方案</a>
					<div>
						德州仪器公司(TI)(NYSE:TXN)DLP影院®产品事业部宣布IMAX®公司(Nasdaq:IMAX)将采用DLP影院投影解决方案.根据协议,预计从2008年年中开始,全球商业电影院中部署的IMA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeLaGjp.html" rel="bookmark" class="title">winform中如何获得IE5&lowbar;0当前窗口中的地址</a>
					<div>
						问题描述 winform中如何获得IE5_0当前窗口中的地址 解决方案 解决方案二:没有给小弟回复一下的么.....解决方案三:winform??解决方案四:恩C/S的解决方案五:有点麻烦.通过句柄来 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.060 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
